SystemOrganization addCategory: #'Phexample-Core'!
SystemOrganization addCategory: #'Phexample-Test'!

!Object methodsFor: '*phexample-core' stamp: 'JoeExample 11/8/2009 22:34'!
should
	^PhexMatcher with: self! !

Object subclass: #PhexMatcher
	instanceVariableNames: 'value state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Core'!

!PhexMatcher commentStamp: 'NikoSchwarz 11/20/2009 17:02' prior: 0!
A PhexMatcher is the sort of thing that works out if your example behaves properly or not. Most of the magic happens in expect:using:. 

Please notice that = works unlike in most classes. Therefore, do not store me in a collection!!

Instance Variables
	state:		the items matched so far
	value:		

state
	- xxxxx

value
	- xxxxx
!

!PhexMatcher class methodsFor: 'documentation' stamp: 'CamilloBruni 12/15/2009 15:57'!
rewriteRules
	"Use this TreeRewriter to rewrite existing SUnit tests to Phexample.
	To run the rewrite rules open the following menu:
		Classlist -> refactor -> rewrite code.
	Copy paste the following code in and save it to execute the rewrite rules.
	"
	^RBParseTreeRewriter new
		replace: 'self assert: [ `@expression ]' with: 'self assert: `@expression';
		replace: 'self deny: `@expression' with: 'self assert: `@expression not';
		replace: 'self assert: `@value = `@expected' with: '`@value should = `@expected';
		replace: 'self assert: `@value ~= `@expected' with: '`@value should not = `@expected';
		replace: 'self assert: `@value > `@expected' with: '`@value should > `@expected';
		replace: 'self assert: `@value < `@expected' with: '`@value should < `@expected';
		replace: 'self assert: `@value >= `@expected' with: '`@value should >= `@expected';
		replace: 'self assert: `@value <= `@expected' with: '`@value should <= `@expected';
		replace: 'self assert: (`@value isKindOf: `@type)' with: '`@value should beKindOf: `@type';
		replace: 'self assert: `@expression isNil' with: '`@expression should be isNil';
		replace: 'self assert: `@expression notNil' with: '`@expression should be notNil';
		replace: 'self assert: `@expression `test not' with: '`@expression should not be `test'
			when: [:node | node arguments first receiver selector matchesRegex: '(is|has|not).+|atEnd' ];
		replace: 'self assert: `@expression `test' with: '`@expression should be `test'
			when: [:node | node arguments first selector matchesRegex: '(is|has|not).+|atEnd' ];
		replace: 'self assert: (`@collection includes: `@element) not' with: '`@collection should not be includes: `@element';
		replace: 'self assert: (`@collection includes: `@element)' with: '`@collection should be includes: `@element';
		yourself.
	
! !

!PhexMatcher class methodsFor: 'creation' stamp: 'AdrianNiko 10/14/2009 09:24'!
with: anObject 
	^ self new setValue: anObject! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
< expected
	^self expect: expected using: #<! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
<= expected
	^self expect: expected using: #<=! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianKuhn 11/20/2009 18:46'!
= expected
	self expect: expected using: #=.
	self isShould ifTrue: [ self expectSameHash: expected ].
	^nil
	! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
> expected
	^self expect: expected using: #>! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
>= expected
	^self expect: expected using: #>=! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'AdrianNiko 10/14/2009 17:36'!
be
	state := state copyWith: #be! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'AdrianKuhn 11/22/2009 13:32'!
beFalse
	^self be false! !

!PhexMatcher methodsFor: 'expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:39'!
beKindOf: expectedClass 
	^self 
		expect: [ value isKindOf: expectedClass ]
		describeShould: 
			[ 'expected kind of <1p> but got instance of <2p> (using isKindOf)' 
				expandMacrosWith: expectedClass
				with: value class ]
		describeShouldNot: 
			[ 'expected not to get kind of <1p> but got instance of <2p> (using isKindOf)' 
				expandMacrosWith: expectedClass
				with: value class ]! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianKuhn 12/22/2009 05:50'!
beSameAs: expected
	^ self expect: expected using: #==! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'AdrianKuhn 11/22/2009 13:32'!
beTrue
	^self be true! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:56'!
beginWith: aPrefix
	^self expect: aPrefix using: #beginsWith: 
	! !

!PhexMatcher methodsFor: 'expecting-change' stamp: 'TestRunner 11/9/2009 04:55'!
change: aBlock 
	| before after |
	before := aBlock value.
	value value.
	after := aBlock value.
	before should not = after.	! !

!PhexMatcher methodsFor: 'expecting-change' stamp: 'TestRunner 11/9/2009 05:00'!
change: aBlock from: before to: after
	aBlock value should = before.
	value value.
	aBlock value should = after.! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:57'!
endWith: aSuffix
	^self expect: aSuffix using: #endsWith: 
	! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/20/2009 18:26'!
expect: aBlock describeShould: shouldBlock describeShouldNot: shouldNotBlock
	self isShould ifTrue: [
		aBlock value ifFalse: [TestFailure signal: shouldBlock value].
		^nil ].
	self isShouldNot ifTrue: [
		aBlock value ifTrue: [TestFailure signal: shouldNotBlock value].
		^nil ].
	self error: 'illegal state ', state asString! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/9/2009 08:55'!
expect: expected using: aSymbol
	^self expect: [ value perform: aSymbol with: expected ]
  		describeShould: [ ('expected <1p> but got <2p> (using <3s>)'
								expandMacrosWith: expected
								with: value
								with: aSymbol) ]
  		describeShouldNot: [ ('expected not to get <1p> but got <2p> (using <3s>)'
								expandMacrosWith: expected
								with: value
								with: aSymbol) ]
! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/24/2009 20:20'!
expectSameHash: expected
	value hash = expected hash ifFalse: [
		TestFailure signal: ('expected same hash for <1p> and <2p> (using hash implied by =)'
			expandMacrosWith: value
			with: expected) ].
	^nil! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/24/2009 20:55'!
expectedUnknownMessageToReturn: expected 
	state := state copyWithout: #be.
	^self expect: [ value = expected ]
		describeShould: [ 'expected #<1s> to be <2p>' 
				expandMacrosWith: self findNameOfUnknownMessage
				with: expected ]
		describeShouldNot: [ 'did not expect #<1s> to be <2p>' 
				expandMacrosWith: self findNameOfUnknownMessage
				with: expected ]
	! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'NikoSchwarz 11/24/2009 21:22'!
false
	 ^self expectedUnknownMessageToReturn: false! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/25/2009 01:52'!
findNameOfUnknownMessage
	"	1. walk up the stack until we are outside of this instance.
		2. collect all sent message from bytecode up to program counter.
		3. drop messages until #should and return previous. "
	| frame scanner sent |
	frame := thisContext.
	[	frame := frame sender. 
		frame receiver == self ] whileTrue.
	scanner := InstructionStream on: frame method.
	sent := Stack new.
	scanner scanFor: [ :bytecode | 
		sent push: scanner selectorToSendOrSelf.
		(frame pc - 1) <= scanner pc ].
	[	sent isEmpty ifTrue: [ ^'<unknown>' ].
		sent pop == #should ] whileFalse.
	sent top isSymbol ifFalse: [ ^'<unknown>' ].
	^sent top! !

!PhexMatcher methodsFor: 'private' stamp: 'NikoSchwarz 11/20/2009 17:00'!
hash
	self error: 'Don''t put a matcher into a dictionary. It does not behave ordinarily on ='! !

!PhexMatcher methodsFor: 'expecting-collections' stamp: 'AdrianKuhn 11/24/2009 21:43'!
include: element
	self expect: element using: #includes: ! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianNiko 10/14/2009 17:35'!
initialize 
 state := #()! !

!PhexMatcher methodsFor: 'private' stamp: 'NikoSchwarz 11/24/2009 16:59'!
isShould
	^state = #() or: [state = #(be)]! !

!PhexMatcher methodsFor: 'private' stamp: 'NikoSchwarz 11/24/2009 15:00'!
isShouldNot
	^state = #(not) or: [state = #(not be)]! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:37'!
matchRegex: regexString
	
	^self expect: regexString using: #matchesRegex:! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianNiko 10/14/2009 17:36'!
not
	state := state copyWith: #not! !

!PhexMatcher methodsFor: 'expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:37'!
respondTo: aSelector
	^self 
		expect: [ value respondsTo: aSelector ]
		describeShould: 
			[ 'expected <1p> to respond to <2p> (using respondsTo:)' 
				expandMacrosWith: value 
			   with: aSelector ]
		describeShouldNot: 
			[ 'expected <1p> not to respond to <2p> (using respondsTo:)' 
				expandMacrosWith: value 
			   with: aSelector ]! !

!PhexMatcher methodsFor: 'expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:27'!
runWithin: aDuration 
	^ self
		expect: [[value value.
			true]
				valueWithin: aDuration
				onTimeout: [false]]
		describeShould: ['expected to run within <1p> but took longer' expandMacrosWith: aDuration]
		describeShouldNot: ['expected to take longer then <1p> but was faster' expandMacrosWith: aDuration]! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianNiko 10/14/2009 09:25'!
setValue: anObject
	value := anObject ! !

!PhexMatcher methodsFor: 'expecting-error' stamp: 'NikoSchwarz 7/5/2010 11:07'!
signal: errorClass 
	
	value on: Exception do: [ :ex |
		^ex should beKindOf: errorClass ].
	self expect: false describeShould: ['Should raise <1p> but was none' expandMacrosWith: errorClass] describeShouldNot: ['Should not raise <1p> but did' expandMacrosWith: errorClass]! !

!PhexMatcher methodsFor: 'expecting-error' stamp: 'JoeExample 10/27/2009 18:08'!
signal: errorClass withMessageText: message

	value on: Exception do: [ :ex | 
		ex should beKindOf: errorClass.
		^message isBlock 
			ifTrue: [ message value: ex messageText ]
			ifFalse: [ ^ex messageText should = message ]].
	TestFailure signal: ('Should raise <1p> but was none' expandMacrosWith: errorClass).! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'NikoSchwarz 11/24/2009 21:22'!
true
	^self expectedUnknownMessageToReturn: true! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianKuhn 11/20/2009 18:26'!
~= expected
	self expect: expected using: #~=.
	self isShouldNot ifTrue: [ self expectSameHash: expected ].
	^nil
	
	! !

TestResource subclass: #Given
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Core'!

!Given methodsFor: 'dependencies' stamp: 'AdrianKuhn 12/14/2009 20:39'!
consumeReturnValueAt: testMethod
	^(cache includesKey: testMethod)
		ifTrue: [ cache removeKey: testMethod ]
		ifFalse: [ testMethod perform: testMethod selector ]! !

!Given methodsFor: 'dependencies' stamp: 'AdrianKuhn 12/14/2009 20:38'!
produceReturnValueAt: testMethod
	cache at: testMethod ifAbsentPut: [ testMethod perform: testMethod selector ]! !

!Given methodsFor: 'fixture' stamp: 'AdrianKuhn 12/14/2009 19:53'!
setUp
	cache := Dictionary new.! !

!Given methodsFor: 'fixture' stamp: 'AdrianKuhn 12/14/2009 19:53'!
tearDown
    cache := nil! !

TestCase subclass: #Phexample
	instanceVariableNames: 'givenNotGiven'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Core'!

!Phexample commentStamp: 'HenryDorsettCase 11/6/2009 18:56' prior: 0!
Phexample, because well designed tests expand on one another.

Examples see ForExampleStack. 

by Adrian Kuhn and Niko Schwarz  !

Phexample subclass: #ForExampleMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Test'!

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:41'!
shouldBeFalse
  (Set with: 42) isEmpty should beFalse.! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:04'!
shouldBeKindOf
	'hello' should beKindOf: String! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:04'!
shouldBeKindOfSuperclass
	'hello' should beKindOf: Collection! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'AdrianKuhn 12/22/2009 05:50'!
shouldBeSame
	[ self should beSameAs: self ] value should = nil.! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:40'!
shouldBeTrue
	Set new isEmpty should beTrue.
! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:56'!
shouldBeginWith
	'abcdef' should beginWith: 'abc'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-change' stamp: 'AdrianKuhn 11/9/2009 04:57'!
shouldChange
	| list |
	list := OrderedCollection new.
	[ list add: nil ] should change: [ list size ]! !

!ForExampleMatcher methodsFor: 'examples-expecting-change' stamp: 'AdrianKuhn 11/9/2009 05:00'!
shouldChangeFromTo
	| list |
	list := OrderedCollection new add: nil; add: nil; yourself.
	[ list add: nil ] should change: [ list size ] from: 2 to: 3.! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:59'!
shouldContainNameOfBooleanPropertyInMessageTextWhenFailing
	[ nil notNil should beTrue ] should
		signal: TestFailure
		withMessageText: 'expected #notNil to be true'! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:57'!
shouldEndWith
	'abcdef' should endWith: 'def'.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 10/26/2009 16:46'!
shouldEqualFive
	(2 + 3) should = 5! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 17:53'!
shouldGreaterThan
  6 should > 5 ! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 21:02'!
shouldHandlePathologicCaseOfBooleanPropertyWhenFailing
	[ nil should beTrue ] should
		signal: TestFailure
		withMessageText: 'expected #<unknown> to be true'! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 21:09'!
shouldHaveTestsInThisClass
	self class allTestSelectors isEmpty should not be true.
	self class allTestSelectors size should > 20.
	
	! !

!ForExampleMatcher methodsFor: 'examples-expecting-collections' stamp: 'AdrianKuhn 11/24/2009 21:49'!
shouldInclude
	#(foo bar) should include: #foo! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:42'!
shouldIncludeFoo
	(#(foo bar qux) includes: #foo) should beTrue.
! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 17:54'!
shouldLesserThan
  5 should < 6! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 05:37'!
shouldMatchRegex
	'aaa' should matchRegex: 'a*'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:08'!
shouldNotBeFalse
  |set|
	set := Set new. 
	set isEmpty should not be false.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 10:27'!
shouldNotBeKindOfSubclass
	'hello' should not beKindOf: Symbol! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:43'!
shouldNotBeTrue
  	(Set with: 42) isEmpty should not beTrue.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 10/26/2009 16:46'!
shouldNotEqualSeven
	(2 + 3) should not = 7! !

!ForExampleMatcher methodsFor: 'examples-expecting-collections' stamp: 'AdrianKuhn 11/24/2009 21:50'!
shouldNotInclude
	#(foo bar) should not include: #qux! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:38'!
shouldNotMatchRegex
	'aaa' should not matchRegex: 'ba*'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/25/2009 01:51'!
shouldNotOffByOneWhenFindingNameOfUnknownMessage
	[ #() isEmpty should be false should ] " kinda artifical example, 
		but exercises the off-by-one nature of the PC which points after
		#false when looking for the message name, ie we must  make sure
		that we dont search to far which would yield #false instead of
		the correct #isEmpty message."
		should signal: TestFailure
		withMessageText: 'expected #isEmpty to be false'! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'NikoSchwarz 11/11/2009 18:04'!
shouldNotRespondTo
	Object new should not respondTo: #zork! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'NikoSchwarz 11/11/2009 18:02'!
shouldRespondTo
	Object new should respondTo: #yourself! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'AdrianKuhn 12/22/2009 05:48'!
shouldReturnNilWhenTesting
	[ 5 should = 5 ] value should = nil ! !

!ForExampleMatcher methodsFor: 'examples-expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:11'!
shouldRunWithin
	[ "makes the Kessel Run in less than twelve parsecs" ] should runWithin: 10 milliSeconds ! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'JoeExample 10/27/2009 01:23'!
shouldSignal

	[ 5 should = 6 ] should signal: TestFailure.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 01:23'!
shouldSignalIfFiveShouldNotEqualFive

	[ 5 should not = 5 ] should signal: TestFailure.! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 10/27/2009 01:32'!
shouldSignalIfSignalMissing

	[ [ 5 should = 5 ] should signal: TestFailure ] should 
		signal: TestFailure 
		withMessageText: 'Should raise TestFailure but was none'! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'AdrianKuhn 11/9/2009 05:16'!
shouldSignalIfSignalWrong

	[ [ self error ] should signal: TestFailure ] should 
		signal: TestFailure 
		"withMessageText: 'Expected class TestFailure but was Error'"! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:49'!
shouldSignalWhenBeFalseFails
	[ Set new isEmpty should beFalse ] should
		signal: TestFailure
		withMessageText: 'expected #isEmpty to be false'! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:07'!
shouldSignalWhenBeKindOfFails
	[ 'hello' should beKindOf: Number ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'NikoSchwarz 6/8/2010 16:51'!
shouldSignalWhenBeSameFails
	[ 'string' copy should beSameAs: 'string' copy ] 
		should signal: TestFailure 
		withMessageText: 'expected ''string'' but got ''string'' (using ==)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:50'!
shouldSignalWhenBeTrueFails
	[ (Set with: 42) isEmpty should beTrue ] should
		signal: TestFailure
		withMessageText: 'expected #isEmpty to be true'! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 09:04'!
shouldSignalWhenBeginsWithFails
	[ 'abcdef' should beginWith: 'abcX' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''abcX'' but got ''abcdef'' (using beginsWith:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 09:03'!
shouldSignalWhenEndWithFails
	[ 'abcdef' should endWith: 'Xdef' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''Xdef'' but got ''abcdef'' (using endsWith:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'AdrianKuhn 12/22/2009 05:34'!
shouldSignalWhenGreaterThanFails
  [ 5 should > 6 ] should signal: TestFailure withMessageText: 'expected 6 but got 5 (using >)'.
  [ 4 should > 4 ] should signal: TestFailure withMessageText: 'expected 4 but got 4 (using >)'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-collections' stamp: 'AdrianKuhn 11/24/2009 21:50'!
shouldSignalWhenIncludeFails
	[ #(foo bar) should include: #qux ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 11/9/2009 04:34'!
shouldSignalWhenLesserThanFails
  [ 6 should < 5 ] should signal: TestFailure withMessageText: 'expected 5 but got 6 (using <)'.
  [ 4 should < 4 ] should signal: TestFailure withMessageText: 'expected 4 but got 4 (using <)'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:44'!
shouldSignalWhenMatchRegexFails
	[ 'aaa' should matchRegex: 'ba*' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''ba*'' but got ''aaa'' (using matchesRegex:)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:51'!
shouldSignalWhenNotBeFalseFails
	[ (Set with: 42) isEmpty should not beFalse ] should
		signal: TestFailure
		withMessageText: 'did not expect #isEmpty to be false'! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianKuhn 11/24/2009 20:50'!
shouldSignalWhenNotBeTrueFails
	[ Set new isEmpty should not beTrue ] should
		signal: TestFailure
		withMessageText: 'did not expect #isEmpty to be true'! !

!ForExampleMatcher methodsFor: 'examples-expecting-collections' stamp: 'AdrianKuhn 11/24/2009 21:50'!
shouldSignalWhenNotIncludeFails
	[ #(foo bar) should not include: #foo ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:43'!
shouldSignalWhenNotMatchRegexFails
	[ 'aaa' should not matchRegex: 'a*' ] should 
		signal: TestFailure 
		withMessageText: 'expected not to get ''a*'' but got ''aaa'' (using matchesRegex:)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:38'!
shouldSignalWhenNotRespondToFails
	[ Object new should not respondTo: #yourself ] should
		signal: TestFailure
		withMessageText: 'expected an Object not to respond to #yourself (using respondsTo:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:37'!
shouldSignalWhenRespondToFails
	[ Object new should respondTo: #zork ] should
		signal: TestFailure
		withMessageText: 'expected an Object to respond to #zork (using respondsTo:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:28'!
shouldSignalWhenRunWithinFails
	[ [ (Delay forMilliseconds: 20) wait ] should runWithin: 10 milliSeconds ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'AdrianKuhn 12/22/2009 05:50'!
shouldSignalWhenSignalWithMessageTextFails
	[ [ self error: 'foo' ] should 
		signal: Error 
		withMessageText: 'bar' ] on: TestFailure
		do: [ :ex | 
			ex messageText should = 'expected ''bar'' but got ''foo'' (using =)' ]! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 11/9/2009 04:34'!
shouldSignalWithMessage
	
	[ 5 should = 6 ] should 
		signal: TestFailure
		withMessageText: 'expected 6 but got 5 (using =)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 11/9/2009 04:35'!
shouldSignalWithMessageBlock
	
	[ 5 should = 6 ] should 
		signal: TestFailure
		withMessageText: [ :m | 
			m should beKindOf: String.
			m isEmpty should not be true.
			m should = 'expected 6 but got 5 (using =)'.
		]! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'AdrianKuhn 11/24/2009 20:20'!
shouldTestForSameHashWhenExpectingEqualValues
	| factory probe p |
	factory := ClassFactoryForTestCase new.
	probe := factory 
		newSubclassOf: Object 
		instanceVariableNames: 'counter'
		classVariableNames: ''.
	probe compile: 'initialize counter := 0'.
	probe compile: 'hash ^counter := counter + 1'.
	probe compile: 'printOn: stream stream nextPutAll: ''probe'''.
	p := probe new.
	p hash should = 1.
	p hash should = 2.
	p hash should = 3.
	[ p should = p ] should signal: TestFailure
		withMessageText: 'expected same hash for probe and probe (using hash implied by =)'.
	[ p should not ~= p ] should signal: TestFailure 
		withMessageText: 'expected same hash for probe and probe (using hash implied by =)'.
	factory cleanUp.

! !

Phexample subclass: #ForExampleStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Test'!

!ForExampleStack methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 20:37'!
shouldBeEmpty
	| stack |
	stack := Stack new.
	stack isEmpty should beTrue.
	stack size should = 0.
	^ stack! !

!ForExampleStack methodsFor: 'examples' stamp: 'NikoSchwarz 6/8/2010 16:51'!
shouldFailWhenPopEmpty
	| stack |
	stack := self given: #shouldBeEmpty.
	[ stack pop ] should signal: Error withMessageText: 'this collection is empty'.! !

!ForExampleStack methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 20:37'!
shouldLastInFirstOut
	| stack |
	stack := self given: #shouldPushMoreElements.
	stack pop should = 13.
	stack pop should = 7.
	stack pop should = 42.
	stack isEmpty should beTrue.! !

!ForExampleStack methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 20:37'!
shouldPopElement
	| stack |
	stack := self given: #shouldPushElement.
	stack pop should = 42.
	stack isEmpty should beTrue.
	stack size should = 0.! !

!ForExampleStack methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 20:37'!
shouldPushElement
	| stack |
	stack := self given: #shouldBeEmpty.
	stack push: 42.
	stack isEmpty should not beTrue.
	stack size should = 1.
	stack top should = 42.
	^ stack! !

!ForExampleStack methodsFor: 'examples' stamp: 'AdrianKuhn 11/24/2009 20:38'!
shouldPushMoreElements
	| stack |
	stack := self given: #shouldPushElement.
	stack push: 7.
	stack push: 13.
	stack isEmpty should not beTrue.
	stack size should = 3.
	stack top should = 13.
	^stack! !

!Phexample class methodsFor: 'accessing' stamp: 'NikoSchwarz 6/8/2010 16:49'!
allTestSelectors
	|selectors|
	selectors := self allSelectors copy.
	selectors removeAll: Phexample allSelectors.
	^ selectors select: [ :each | each numArgs isZero and: [ each asLowercase includesSubString: 'should' ]]
			! !

!Phexample class methodsFor: 'accessing' stamp: 'AdrianKuhn 12/22/2009 05:43'!
resources
	^{ Given }! !

!Phexample methodsFor: 'equality' stamp: 'AdrianKuhn 12/14/2009 20:13'!
= example
	^self class = example class and: [ self selector = example selector ]! !

!Phexample methodsFor: 'private' stamp: 'JoeExample 11/8/2009 22:34'!
cleanUpInstanceVariables
	| names |
	names := self class allInstVarNames asOrderedCollection.
	names removeAll: Phexample allInstVarNames.
	names do: [ :name | self instVarNamed: name put: nil ]! !

!Phexample methodsFor: 'dependencies' stamp: 'NikoSchwarz 4/8/2010 10:38'!
given: anExampleName 
	self should respondTo: anExampleName.
	^ [ Given current consumeReturnValueAt: (self class selector: anExampleName) ] 
		on: TestResult error
		do: [ :ex | 
			givenNotGiven := true.
			ex pass ]! !

!Phexample methodsFor: 'equality' stamp: 'AdrianKuhn 12/14/2009 20:13'!
hash
	^self class hash bitXor: self selector hash! !

!Phexample methodsFor: 'private' stamp: 'AdrianKuhn 12/22/2009 05:44'!
performTest
	^Given current produceReturnValueAt: self. ! !

!Phexample methodsFor: 'private' stamp: 'JoeExample 11/9/2009 09:24'!
shouldPass
	^ super shouldPass and: [ (givenNotGiven = true) not ]! !

TestCase subclass: #PhexampleTest
	instanceVariableNames: 'factory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Test'!

!PhexampleTest class methodsFor: 'as yet unclassified' stamp: 'AdrianKuhn 12/22/2009 06:06'!
allTestSelectors 
	^self selectors select: [ :each | each beginsWith: 'should' ] ! !

!PhexampleTest methodsFor: 'fixture' stamp: 'AdrianKuhn 12/22/2009 06:21'!
setUp
	factory := ClassFactoryForTestCase new! !

!PhexampleTest methodsFor: 'examples' stamp: 'AdrianKuhn 12/22/2009 06:21'!
shouldExecuteExampleMethod
	| class testcase hasRun result |
	class := factory newSubclassOf: Phexample
		instanceVariableNames: 'action'
		classVariableNames: ''.
	class compile: 'shouldRun action value'.
	class compile: 'action: aBlock action := aBlock'.
	testcase := class selector: #shouldRun.
	testcase action: [ hasRun := true ].
	result := testcase run.
	result tests size should = 1.
	result passed size should = 1.
	hasRun should be true! !

!PhexampleTest methodsFor: 'examples' stamp: 'AdrianKuhn 12/22/2009 06:07'!
shouldHaveGivenAsResource
	Phexample resources should include: Given ! !

!PhexampleTest methodsFor: 'examples' stamp: 'NikoSchwarz 4/8/2010 10:57'!
shouldNicelyHandleNotifications
	"Checks whether notifications are properly ignored, both immediately and in dependent tests."
	| class testcase hasRun result suite |
	class := factory newSubclassOf: Phexample
		instanceVariableNames: ''
		classVariableNames: ''.
	class compile: 'throwNotification Notification  signal:''Waa!!'''.
	class compile: 'consumeNotification   self given: #throwNotification. '.
	suite := TestSuite new.
	suite 
		addTest: (class selector: #throwNotification);
		addTest: ( class selector: #consumeNotification).
	result := suite run.
	result passedCount should = 2 .
	result	failureCount should = 0.
	result	errorCount should = 0 .
	result	unexpectedPassCount should = 0.
	result	unexpectedErrorCount should = 0.
	result	unexpectedFailureCount should = 0.
			! !

!PhexampleTest methodsFor: 'examples' stamp: 'AdrianKuhn 12/22/2009 05:49'!
shouldNotHaveTestsInPhexample
	Phexample allTestSelectors isEmpty should be true.
	
	! !

!PhexampleTest methodsFor: 'fixture' stamp: 'AdrianKuhn 12/22/2009 06:22'!
tearDown
	factory cleanUp! !
